## viennacl 1.1.2

=== CMakeLists.txt ===
PROJECT(ViennaCL)

cmake_minimum_required(VERSION 2.6)

#if you don't want the full compiler output, remove or comment the following line
SET(CMAKE_VERBOSE_MAKEFILE ON)


# ************************** Section 1: Configure external dependencies **************************

#
# If you are interested in the impact of different kernel parameters on performance,
# you may want to give ViennaProfiler a try (see http://sourceforge.net/projects/viennaprofiler/)
# Set your connection parameters in examples/parameters/common_vprof.hpp accordingly.
#
#SET(ENABLE_VIENNAPROFILER ON)
#SET(MYSQLPATH "/opt/boost")        #path to MySQL header files
#SET(MYSQLPPPATH "/opt/boost")        #path to MySQL++ header files


#
# If you want to build the examples that use boost::numeric::ublas, enable the following:
#
#SET(ENABLE_UBLAS ON)
#SET(BOOSTPATH "/opt/boost")             #put your path to boost here if not in global include folder

#
# alternate boost path for macs
#
IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
   INCLUDE_DIRECTORIES("/opt/local/include") 
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")



#
# If you want to build the examples that use Eigen, uncomment the following:
#
#SET(ENABLE_EIGEN ON)
#SET(EIGENPATH "/path/to/eigen/")  #put your path to Eigen here if not in global include folder


#
# If you want to build the examples that use MTL4, uncomment the following:
#
#SET(ENABLE_MTL4 ON)
#SET(MTL4PATH "/path/to/MTL-4/")  #put your path to MTL4 here if not in global include folder



# **************************  Section 2: Configure OpenCL **************************

#
# AMD APP SDK:
# add include and lib path to build environment
# The linker will most likely pick the correct link directory
# Otherwise, feel free to comment the wrong link directory for your machine.
#
# The following lines can be commented if AMD APP SDK is not in use.
#
SET(AppSDK $ENV{AMDAPPSDKROOT})
IF(AppSDK)
 INCLUDE_DIRECTORIES($ENV{AMDAPPSDKROOT}/include) 
 LINK_DIRECTORIES($ENV{AMDAPPSDKROOT}/lib/x86)       #use this on 32 bit systems
 LINK_DIRECTORIES($ENV{AMDAPPSDKROOT}/lib/x86_64)    #use this on 64 bit systems
ENDIF(AppSDK)
#
# Note that the environment variable was ATISTREAMSDKROOT in older versions of the SDK:
#
SET(StreamSDK $ENV{ATISTREAMSDKROOT})
IF(StreamSDK)
 INCLUDE_DIRECTORIES($ENV{ATISTREAMSDKROOT}/include) 
 LINK_DIRECTORIES($ENV{ATISTREAMSDKROOT}/lib/x86)       #use this on 32 bit systems
 LINK_DIRECTORIES($ENV{ATISTREAMSDKROOT}/lib/x86_64)    #use this on 64 bit systems
ENDIF(StreamSDK)


#
# Intel OpenCL SDK:
# add include and lib path to build environment
# The linker will most likely pick the correct link directory
# Otherwise, feel free to comment the wrong link directory for your machine.
#
# The following lines can be commented if Intel OpenCL SDK is not in use.
#
SET(IntelSDK $ENV{INTELOCLSDKROOT})
IF(IntelSDK)
 INCLUDE_DIRECTORIES($ENV{INTELOCLSDKROOT}/include) 
 LINK_DIRECTORIES($ENV{INTELOCLSDKROOT}/lib/x86)       #use this on 32 bit systems
 LINK_DIRECTORIES($ENV{INTELOCLSDKROOT}/lib/x64)    #use this on 64 bit systems
ENDIF(IntelSDK)

#
# For NVIDIA hardware, there should be no need for additional configurations at this point
#


# ************************** Section 3: ViennaCL standalone builds **************************

#
# Specify include and source directory
#
INCLUDE_DIRECTORIES(".")
INCLUDE_DIRECTORIES("external/")


#add definitions, compiler switches, etc.
IF(DEFINED CMAKE_BUILD_TYPE)
 SET (CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE})
ELSE()
 SET (CMAKE_BUILD_TYPE Release)
ENDIF()

#
# Set high warning level on GCC and enable optimizations (or debug)
#
IF(CMAKE_COMPILER_IS_GNUCXX)
   #ADD_DEFINITIONS(-Wall -O0 -g)             #debug build
   ADD_DEFINITIONS(-Wall -pedantic -O3)       #release build
ENDIF(CMAKE_COMPILER_IS_GNUCXX)

#
# Standalone ViennaCL executables
#

#tutorials:
ADD_EXECUTABLE(blas1 examples/tutorial/blas1.cpp)
ADD_EXECUTABLE(custom-kernels examples/tutorial/custom-kernels.cpp)
ADD_EXECUTABLE(custom-context examples/tutorial/custom-context.cpp)
ADD_EXECUTABLE(viennacl-info examples/tutorial/viennacl-info.cpp)

#benchmarks
ADD_EXECUTABLE(vectorbench examples/benchmarks/vector.cpp)
ADD_EXECUTABLE(openclbench examples/benchmarks/opencl.cpp)
ADD_EXECUTABLE(blas3bench examples/benchmarks/blas3.cpp)

#parameters:
ADD_EXECUTABLE(vectorparams examples/parameters/vector.cpp
                            external/pugixml/src/pugixml.cpp)
ADD_EXECUTABLE(matrixparams examples/parameters/matrix.cpp
                            external/pugixml/src/pugixml.cpp)
ADD_EXECUTABLE(sparseparams examples/parameters/sparse.cpp
                            external/pugixml/src/pugixml.cpp)
ADD_EXECUTABLE(parameter_reader examples/parameters/parameter_reader.cpp
                                external/pugixml/src/pugixml.cpp)                        

#
# Mac OS X specific linker part
#
IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
   set(CMAKE_EXE_LINKER_FLAGS "-framework OpenCL")
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

#
# Linux and Windows specific linker part
#
IF((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR (${CMAKE_SYSTEM_NAME} MATCHES "Windows"))
   #tutorials
   TARGET_LINK_LIBRARIES(blas1 OpenCL)
   TARGET_LINK_LIBRARIES(custom-kernels OpenCL)
   TARGET_LINK_LIBRARIES(custom-context OpenCL)
   TARGET_LINK_LIBRARIES(viennacl-info OpenCL)

   #benchmarks
   TARGET_LINK_LIBRARIES(vectorbench OpenCL)
   TARGET_LINK_LIBRARIES(openclbench OpenCL)
   TARGET_LINK_LIBRARIES(blas3bench OpenCL)

   #parameter estimation
   TARGET_LINK_LIBRARIES(vectorparams OpenCL)
   TARGET_LINK_LIBRARIES(matrixparams OpenCL)
   TARGET_LINK_LIBRARIES(sparseparams OpenCL)
   TARGET_LINK_LIBRARIES(parameter_reader OpenCL)   
ENDIF((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR (${CMAKE_SYSTEM_NAME} MATCHES "Windows"))


# ************************** Section 4: ViennaCL with external libraries **************************

#
# ViennaProfiler related configuration
#
IF(DEFINED ENABLE_VIENNAPROFILER)
   INCLUDE_DIRECTORIES(${MYSQLPATH})
   INCLUDE_DIRECTORIES(${MYSQLPPPATH})

   #vector:
   ADD_EXECUTABLE(vectorparams_vprof examples/parameters/vector.cpp
                                     external/pugixml/src/pugixml.cpp)
   SET_PROPERTY(TARGET vectorparams_vprof PROPERTY COMPILE_DEFINITIONS ENABLE_VIENNAPROFILER)
   TARGET_LINK_LIBRARIES(vectorparams_vprof OpenCL mysqlpp)

   #dense matrix:
   ADD_EXECUTABLE(matrixparams_vprof examples/parameters/matrix.cpp
                                     external/pugixml/src/pugixml.cpp)
   SET_PROPERTY(TARGET matrixparams_vprof PROPERTY COMPILE_DEFINITIONS ENABLE_VIENNAPROFILER)
   TARGET_LINK_LIBRARIES(matrixparams_vprof OpenCL mysqlpp)

   #sparse matrix:
   ADD_EXECUTABLE(sparseparams_vprof examples/parameters/sparse.cpp
                                     external/pugixml/src/pugixml.cpp)
   SET_PROPERTY(TARGET sparseparams_vprof PROPERTY COMPILE_DEFINITIONS ENABLE_VIENNAPROFILER)
   TARGET_LINK_LIBRARIES(sparseparams_vprof OpenCL mysqlpp)
ENDIF(DEFINED ENABLE_VIENNAPROFILER)


#
# ublas related configuration
#
IF(DEFINED ENABLE_UBLAS)
  INCLUDE_DIRECTORIES(${BOOSTPATH})
  
  #tutorials:
  ADD_EXECUTABLE(blas2 examples/tutorial/blas2.cpp) 
  ADD_EXECUTABLE(blas3 examples/tutorial/blas3.cpp)
  ADD_EXECUTABLE(iterative examples/tutorial/iterative.cpp)
  ADD_EXECUTABLE(iterative-ublas examples/tutorial/iterative-ublas.cpp)

  #benchmarks:
  ADD_EXECUTABLE(sparsebench examples/benchmarks/sparse.cpp)
  ADD_EXECUTABLE(solverbench examples/benchmarks/solver.cpp)

  IF((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR (${CMAKE_SYSTEM_NAME} MATCHES "Windows"))
    TARGET_LINK_LIBRARIES(iterative OpenCL)
    TARGET_LINK_LIBRARIES(blas2 OpenCL)
    TARGET_LINK_LIBRARIES(blas3 OpenCL)

    TARGET_LINK_LIBRARIES(sparsebench OpenCL)
    TARGET_LINK_LIBRARIES(solverbench OpenCL)
  ENDIF((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR (${CMAKE_SYSTEM_NAME} MATCHES "Windows"))

ENDIF(DEFINED ENABLE_UBLAS)



#
# Eigen related configuration
#
IF(DEFINED ENABLE_EIGEN)
  INCLUDE_DIRECTORIES(${EIGENPATH})
  ADD_EXECUTABLE(iterative-eigen examples/tutorial/iterative-eigen.cpp)
  ADD_EXECUTABLE(eigen-with-viennacl examples/tutorial/eigen-with-viennacl.cpp)
  
  IF((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR (${CMAKE_SYSTEM_NAME} MATCHES "Windows"))
    TARGET_LINK_LIBRARIES(eigen-with-viennacl OpenCL)
  ENDIF((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR (${CMAKE_SYSTEM_NAME} MATCHES "Windows"))
ENDIF(DEFINED ENABLE_EIGEN)



#
# MTL4 related configuration
#
IF(DEFINED ENABLE_MTL4)
  INCLUDE_DIRECTORIES(${MTL4PATH})
  ADD_EXECUTABLE(iterative-mtl4 examples/tutorial/iterative-mtl4.cpp)
  ADD_EXECUTABLE(mtl4-with-viennacl examples/tutorial/mtl4-with-viennacl.cpp)

  IF((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR (${CMAKE_SYSTEM_NAME} MATCHES "Windows"))
    TARGET_LINK_LIBRARIES(mtl4-with-viennacl OpenCL)
  ENDIF((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR (${CMAKE_SYSTEM_NAME} MATCHES "Windows"))
ENDIF(DEFINED ENABLE_MTL4)

=== tests/CMakeLists.txt ===
PROJECT(ViennaCLTests)

cmake_minimum_required(VERSION 2.4)

#-----------------------------------------------------------------------------
#specify include and source directory
INCLUDE_DIRECTORIES("../")    # ViennaCL root

# alternate boost path for macs
IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
   INCLUDE_DIRECTORIES("/opt/local/include") 
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

# **************************  Section 2: Configure OpenCL **************************

#
# AMD APP SDK:
# add include and lib path to build environment
# The linker will most likely pick the correct link directory
# Otherwise, feel free to comment the wrong link directory for your machine.
#
# The following lines can be commented if AMD APP SDK is not in use.
#
SET(AppSDK $ENV{AMDAPPSDKROOT})
IF(AppSDK)
 INCLUDE_DIRECTORIES($ENV{AMDAPPSDKROOT}/include) 
 LINK_DIRECTORIES($ENV{AMDAPPSDKROOT}/lib/x86)       #use this on 32 bit systems
 LINK_DIRECTORIES($ENV{AMDAPPSDKROOT}/lib/x86_64)    #use this on 64 bit systems
ENDIF(AppSDK)
#
# Note that the environment variable was ATISTREAMSDKROOT in older versions of the SDK:
#
SET(StreamSDK $ENV{ATISTREAMSDKROOT})
IF(StreamSDK)
 INCLUDE_DIRECTORIES($ENV{ATISTREAMSDKROOT}/include) 
 LINK_DIRECTORIES($ENV{ATISTREAMSDKROOT}/lib/x86)       #use this on 32 bit systems
 LINK_DIRECTORIES($ENV{ATISTREAMSDKROOT}/lib/x86_64)    #use this on 64 bit systems
ENDIF(StreamSDK)


#
# Intel OpenCL SDK:
# add include and lib path to build environment
# The linker will most likely pick the correct link directory
# Otherwise, feel free to comment the wrong link directory for your machine.
#
# The following lines can be commented if Intel OpenCL SDK is not in use.
#
SET(IntelSDK $ENV{INTELOCLSDKROOT})
IF(IntelSDK)
 INCLUDE_DIRECTORIES($ENV{INTELOCLSDKROOT}/include) 
 LINK_DIRECTORIES($ENV{INTELOCLSDKROOT}/lib/x86)       #use this on 32 bit systems
 LINK_DIRECTORIES($ENV{INTELOCLSDKROOT}/lib/x64)    #use this on 64 bit systems
ENDIF(IntelSDK)

#
# For NVIDIA hardware, there should be no need for additional configurations at this point
#

#-----------------------------------------------------------------------------

#add definitions, compiler switches, etc.
IF(CMAKE_COMPILER_IS_GNUCXX)
   #ADD_DEFINITIONS(-Wall -O0 -g)
   ADD_DEFINITIONS(-Wall -pedantic -O3)
ENDIF(CMAKE_COMPILER_IS_GNUCXX)
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# Configure Dart testing support.  This should be done before any
# MESSAGE(FATAL_ERROR ...) commands are invoked.
INCLUDE(CTest)
ENABLE_TESTING()
IF(BUILD_TESTING)
  SET(BUILDNAME "${BUILDNAME}" CACHE STRING "Name of build on the dashboard")
  MARK_AS_ADVANCED(BUILDNAME)
ENDIF(BUILD_TESTING)

#-----------------------------------------------------------------------------
# add the source files which should be tested without the trailing *.cpp
SET(PROGS scalar vector matrix sparse iterators blas3)
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
FOREACH(PROG ${PROGS})
   ADD_EXECUTABLE(${PROG} ../src/${PROG}.cpp)
   ADD_test(${PROG} ${PROG})
   TARGET_LINK_LIBRARIES(${PROG} OpenCL)
ENDFOREACH(PROG)

ADD_EXECUTABLE(external_linkage  ../src/external_1.cpp
                                 ../src/external_2.cpp)

#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# Mac OS X specific linker part
IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
   set(CMAKE_EXE_LINKER_FLAGS "-framework OpenCL")
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

# Linux specific linker part
IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
   set(CMAKE_EXE_LINKER_FLAGS "-lOpenCL")
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
#-----------------------------------------------------------------------------

=== doc/manual/Makefile ===

FILE=viennacl

# ----------------------------------------------------------------------------

build: build-latex build-dvi build-pdf build-clean
	mv $(FILE).pdf ../

clean: build-clean

# ----------------------------------------------------------------------------

build-latex:
	latex ${FILE}.tex
	latex ${FILE}.tex
	bibtex ${FILE}
	latex ${FILE}.tex	
	bibtex ${FILE}
	latex ${FILE}.tex		
	
build-dvi:
	dvips -Ppdf -G0 -ta4 $(FILE).dvi 
	
build-pdf:
	ps2pdf  -dPDFSETTINGS=/prepress -dCompatibilityLevel=1.3 \
           -dMAxSubsetPct=100 -dSubsetFonts=true \
           -dEmbedAllFonts=true -sPAPERSIZE=a4 \
           -dAutoRotatePages=/None -dOptimize=true $(FILE).ps

build-clean:
	rm -f *.dvi *.log *.aux *.idx *.ps *.out *.toc *~ *.backup

=== debian/changelog ===
viennacl (1.1.2-6) unstable; urgency=low

  * Copyright info for CL/* external/pugixml/*

 -- Michael Wild <themiwi@users.sourceforge.net>  Tue, 02 Aug 2011 10:30:34 +0200

viennacl (1.1.2-5) unstable; urgency=low

  * Fix regex in debian/watch
  * Remove generated files and re-generate when building
  * Link auxiliary/converter against libboost_system-mt
  * Force the Boost.Filesystem version 2 API for auxiliary/converter.cpp

 -- Michael Wild <themiwi@users.sourceforge.net>  Tue, 02 Aug 2011 09:35:51 +0200

viennacl (1.1.2-4) unstable; urgency=low

  * Bump Standards-Version to 3.9.2

 -- Michael Wild <themiwi@users.sourceforge.net>  Tue, 12 Jul 2011 19:45:08 +0200

viennacl (1.1.2-3) unstable; urgency=low

  * Use dpkg-mergechangelogs to merge debian/changelog
  * Build tests verbosely

 -- Michael Wild <themiwi@users.sourceforge.net>  Tue, 05 Jul 2011 19:39:40 +0200

viennacl (1.1.2-2) unstable; urgency=low

  * Add patch to properly link against libOpenCL

 -- Michael Wild <themiwi@users.sourceforge.net>  Tue, 05 Jul 2011 17:26:15 +0200

viennacl (1.1.2-1) unstable; urgency=low

  * Initial release (Closes: #620135)

 -- Michael Wild <themiwi@users.sourceforge.net>  Mon, 04 Jul 2011 16:14:19 +0200

=== debian/control ===
Source: viennacl
Section: contrib/science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Michael Wild <themiwi@users.sourceforge.net>
Build-Depends: debhelper (>= 7.0.50~), poppler-utils, asciidoc, lynx,
 cmake (>= 2.6), libboost-filesystem-dev, texlive-latex-extra,
 texlive-latex-recommended, texlive-fonts-recommended, texlive-pstricks,
 ghostscript, doxygen, opencl-headers, libopencl1
Standards-Version: 3.9.2
DM-Upload-Allowed: yes
Homepage: http://viennacl.sourceforge.net
Vcs-Git: git://git.debian.org/git/debian-science/packages/viennacl.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/viennacl.git

Package: libviennacl-dev
Architecture: all
Section: contrib/libdevel
Depends: ${misc:Depends}, opencl-headers, libopencl1
Suggests: libeigen2-dev, libboost-dev, libviennacl-doc
Description: Scientific computing library written in C++ based on OpenCL
 The Vienna Computing Library (ViennaCL) is a scientific computing library
 written in C++ and based on OpenCL. It allows simple, high-level access to the
 vast computing resources available on parallel architectures such as GPUs and
 is primarily focused on common linear algebra operations (BLAS levels 1, 2 and
 3) and the solution of large systems of equations by means of iterative
 methods with optional preconditioner.
 .
 ViennaCL is header-only with no binary library and projects using it only need
 to link against a conforming OpenCL implementation.

Package: libviennacl-doc
Architecture: all
Section: contrib/doc
Depends: ${misc:Depends}
Suggests: libviennacl-dev
Description: ViennaCL API and user documentation
 The Vienna Computing Library (ViennaCL) is a scientific computing library
 written in C++ and based on OpenCL. It allows simple, high-level access to the
 vast computing resources available on parallel architectures such as GPUs and
 is primarily focused on common linear algebra operations (BLAS levels 1, 2 and
 3) and the solution of large systems of equations by means of iterative
 methods with optional preconditioner.
 .
 This package contains the Doxygen-generated source code and the user
 documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# This has to be exported to make some magic below work.
export DH_OPTIONS

%:
	dh --sourcedirectory=tests --builddirectory=tests/build $@

override_dh_auto_configure: custom_clean

override_dh_auto_build:
	@cd auxiliary && ./convert.sh
	@cd doc && doxygen
	@$(MAKE) -C doc/manual build

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_configure
	dh_auto_build -- VERBOSE=1
	dh_auto_build -- ARGS="-VV" test || \
	  echo "== ONE OR MORE TESTS FAILED! =="
else
	@echo "== SKIPPING TESTS (nocheck in DEB_BUILD_OPTIONS) =="
endif

override_dh_install:
	dh_install
	mkdir debian/tmp
	pdftotext -f 47 -l 50 -nopgbrk -r 150                                 \
	  -x 130 -y 160 -W 980 -H 1440 -enc ASCII7                            \
	  doc/viennacl.pdf - |                                                \
	  sed -e 's/^Change Logs/= &\n/'                                      \
	      -e '/^Version [0-9]\.[0-9]\.x/d'                                \
	      -e 's/^Version [0-9]\./== &/'                                   \
	      -e '/^\* / i \ ' |                                              \
	  asciidoc -f /etc/asciidoc/text.conf - |                             \
	  lynx -dump --stdin > debian/tmp/changelog

custom_clean:
	@rm -f  auxiliary/converter
	@rm -f  auxiliary/generate-blas3-prod-align1
	@rm -f  auxiliary/generate-blas3-solve-align1
	@rm -rf CL
	@rm -rf doc/doxygen
	@rm -f  doc/viennacl.pdf
	@rm -f  doc/manual/*.bbl doc/manual/*.blg
	@rm -rf external
	@rm -rf viennacl/linalg/kernels/*
	@grep -rl 'file automatically generated' auxiliary/*/ | xargs rm -f

=== debian/watch ===
version=3

http://sf.net/viennacl/ViennaCL-(\d.*)\.tar\.gz

## viennacl 1.2.0

=== CMakeLists.txt ===
# Project setup
###############

cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

project(ViennaCL)


#
# User customizations if CMake does not find Boost or OpenCL
#

# Set boost path here if not found automatically by CMake
#SET(BOOST_ROOT "C:/Program\ Files\ (x86)/boost/boost_1_42")     # adjust this on Windows
#SET(BOOST_ROOT "/opt/local/include")                            # adjust this on MacOS or Linux

# For out-of-the-box support on MacOS:
IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  INCLUDE_DIRECTORIES("/opt/local/include") 
  set(CMAKE_EXE_LINKER_FLAGS "-framework OpenCL")
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")


# Common options - There is usually no need to change anything below this line
################

set(VERSION_MAJOR 1)
set(VERSION_MINOR 2)
set(VERSION_PATCH 0)
set(VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

include(ViennaCLCommon)

# Set release build:
IF(DEFINED CMAKE_BUILD_TYPE)
 SET (CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE})
ELSE()
 SET (CMAKE_BUILD_TYPE Release)
ENDIF()

# User options
##############

option(BUILD_DOXYGEN_DOCS "Build the Doxygen-generated API docs" ON)

option(BUILD_MANUAL "Build the PDF manual" ON)

mark_as_advanced(BUILD_DOXYGEN_DOCS BUILD_MANUAL)

# Find prerequisites
####################

if(BUILD_DOXYGEN_DOCS)
   find_package(Doxygen REQUIRED)
endif()

if(BUILD_MANUAL)
   find_package(LATEX REQUIRED)
endif()

# Compile options
#################

include_directories(BEFORE ${PROJECT_SOURCE_DIR})

# Subdirectories
################

add_subdirectory(auxiliary)

if(BUILD_EXAMPLES)
   add_subdirectory(examples)
endif()

if(BUILD_TESTING)
   add_subdirectory(tests)
endif()

add_subdirectory(doc)

# Install
#########

install(DIRECTORY viennacl
   DESTINATION ${INSTALL_INCLUDE_DIR} COMPONENT dev
   FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp")

=== auxiliary/CMakeLists.txt ===
include_directories(${Boost_INCLUDE_DIRS})

add_executable(generate-blas3-solve-align1 generate-blas3-solve-align1.cpp)
add_executable(generate-blas3-prod-align1 generate-blas3-prod-align1.cpp)

function(generate_blas3_prod_align1 outvar)
   set(crstr_0 col)
   set(crstr_1 row)
   set(ATstr_0 A)
   set(ATstr_1 T)
   set(outfiles)

   foreach(ar 0 1) # A is column/row major
   foreach(br 0 1) # B is column/row major
   foreach(cr 0 1) # C is column/row major
   foreach(at 0 1) # A is (not) transposed
   foreach(bt 0 1) # B is (not) transposed
      set(d "${CMAKE_CURRENT_BINARY_DIR}")
      set(d "${d}/matrix_prod_${crstr_${ar}}_${crstr_${br}}_${crstr_${cr}}")
      set(d "${d}/align1")
      file(MAKE_DIRECTORY "${d}")
      set(o "${d}/prod_${ATstr_${at}}${ATstr_${bt}}.cl")
      file(RELATIVE_PATH ro "${CMAKE_CURRENT_BINARY_DIR}" "${o}")
      add_custom_command(OUTPUT "${o}"
         COMMAND generate-blas3-prod-align1
            ${ar} ${br} ${cr} ${at} ${bt} > "${o}"
         COMMENT "Generating ${ro}"
         WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
         VERBATIM)
      list(APPEND outfiles "${o}")
   endforeach()
   endforeach()
   endforeach()
   endforeach()
   endforeach()
   set(${outvar} "${outfiles}" PARENT_SCOPE)
endfunction()

function(generate_blas3_solve_align1 outvar)
   set(crstr_0 col)
   set(crstr_1 row)
   set(tstr_0)
   set(tstr_1 trans_)
   set(ulstr_0 lower)
   set(ulstr_1 upper)
   set(unitstr_0)
   set(unitstr_1 unit_)
   set(outfiles)

   foreach(ar 0 1) # A is column/row major
   foreach(br 0 1) # A is column/row major
   foreach(at 0 1) # A is transposed
   foreach(bt 0 1) # B is transposed
   foreach(ul 0 1) # upper/lower
   foreach(un 0 1) # unit
      set(d "${CMAKE_CURRENT_BINARY_DIR}")
      set(d "${d}/matrix_solve_${crstr_${ar}}_${crstr_${br}}")
      set(d "${d}/align1")
      file(MAKE_DIRECTORY "${d}")
      set(o "${d}/${tstr_${at}}${unitstr_${un}}${ulstr_${ul}}_${tstr_${bt}}solve.cl")
      file(RELATIVE_PATH ro "${CMAKE_CURRENT_BINARY_DIR}" "${o}")
      add_custom_command(OUTPUT "${o}"
         COMMAND generate-blas3-solve-align1
            ${ar} ${br} ${at} ${bt} ${ul} ${un} > "${o}"
         COMMENT "Generating ${ro}"
         WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
         VERBATIM)
      list(APPEND outfiles "${o}")
   endforeach()
   endforeach()
   endforeach()
   endforeach()
   endforeach()
   endforeach()
   set(${outvar} "${outfiles}" PARENT_SCOPE)
endfunction()

# Matrix-Matrix products
generate_blas3_prod_align1(MATRIX_PROD_SRCS)

# Matrix-Matrix triangular solver
generate_blas3_solve_align1(MATRIX_SOLVE_SRCS)

set(COMPRESSED_MATRIX_SRCS
   compressed_matrix/align1/bicgstab_kernel1.cl
   compressed_matrix/align1/bicgstab_kernel2.cl
   compressed_matrix/align1/jacobi.cl
   compressed_matrix/align1/jacobi_precond.cl
   compressed_matrix/align1/lu_backward.cl
   compressed_matrix/align1/lu_forward.cl
   compressed_matrix/align1/row_scaling_1.cl
   compressed_matrix/align1/row_scaling_2.cl
   compressed_matrix/align1/vec_mul.cl
   compressed_matrix/align4/vec_mul.cl
   compressed_matrix/align8/vec_mul.cl)

set(COORDINATE_MATRIX_SRCS
   coordinate_matrix/align1/vec_mul.cl
   coordinate_matrix/align128/dummy)

set(MATRIX_COL_SRCS
   matrix_col/align1/add.cl
   matrix_col/align1/clear.cl
   matrix_col/align1/cpu_inplace_mult.cl
   matrix_col/align1/fft_direct.cl
   matrix_col/align1/fft_radix2.cl
   matrix_col/align1/fft_radix2_local.cl
   matrix_col/align1/fft_reorder.cl
   matrix_col/align1/inplace_add.cl
   matrix_col/align1/inplace_divide.cl
   matrix_col/align1/inplace_mult.cl
   matrix_col/align1/inplace_sub.cl
   matrix_col/align1/lower_triangular_substitute_inplace.cl
   matrix_col/align1/lu_factorize.cl
   matrix_col/align1/rank1_update.cl
   matrix_col/align1/scaled_rank1_update.cl
   matrix_col/align1/sub.cl
   matrix_col/align1/trans_lower_triangular_substitute_inplace.cl
   matrix_col/align1/trans_unit_lower_triangular_substitute_inplace.cl
   matrix_col/align1/trans_unit_upper_triangular_substitute_inplace.cl
   matrix_col/align1/trans_upper_triangular_substitute_inplace.cl
   matrix_col/align1/trans_vec_mul.cl
   matrix_col/align1/unit_lower_triangular_substitute_inplace.cl
   matrix_col/align1/unit_upper_triangular_substitute_inplace.cl
   matrix_col/align1/upper_triangular_substitute_inplace.cl
   matrix_col/align1/vec_mul.cl
   matrix_col/align16/dummy)

set(MATRIX_ROW_SRCS
   matrix_row/align1/add.cl
   matrix_row/align1/clear.cl
   matrix_row/align1/cpu_inplace_mult.cl
   matrix_row/align1/fft_direct.cl
   matrix_row/align1/fft_radix2.cl
   matrix_row/align1/fft_radix2_local.cl
   matrix_row/align1/fft_reorder.cl
   matrix_row/align1/inplace_add.cl
   matrix_row/align1/inplace_divide.cl
   matrix_row/align1/inplace_mult.cl
   matrix_row/align1/inplace_sub.cl
   matrix_row/align1/lower_triangular_substitute_inplace.cl
   matrix_row/align1/lu_factorize.cl
   matrix_row/align1/rank1_update.cl
   matrix_row/align1/scaled_rank1_update.cl
   matrix_row/align1/sub.cl
   matrix_row/align1/trans_lower_triangular_substitute_inplace.cl
   matrix_row/align1/trans_unit_lower_triangular_substitute_inplace.cl
   matrix_row/align1/trans_unit_upper_triangular_substitute_inplace.cl
   matrix_row/align1/trans_upper_triangular_substitute_inplace.cl
   matrix_row/align1/trans_vec_mul.cl
   matrix_row/align1/unit_lower_triangular_substitute_inplace.cl
   matrix_row/align1/unit_upper_triangular_substitute_inplace.cl
   matrix_row/align1/upper_triangular_substitute_inplace.cl
   matrix_row/align1/vec_mul.cl
   matrix_row/align16/dummy)

set(SCALAR_SRCS
   scalar/align1/add.cl
   scalar/align1/cpu_add.cl
   scalar/align1/cpu_div.cl
   scalar/align1/cpu_inplace_add.cl
   scalar/align1/cpu_inplace_div.cl
   scalar/align1/cpu_inplace_mul.cl
   scalar/align1/cpu_inplace_sub.cl
   scalar/align1/cpu_mul.cl
   scalar/align1/cpu_sub.cl
   scalar/align1/divide.cl
   scalar/align1/inplace_add.cl
   scalar/align1/inplace_div.cl
   scalar/align1/inplace_mul.cl
   scalar/align1/inplace_sub.cl
   scalar/align1/mul.cl
   scalar/align1/sub.cl)

set(VECTOR_SRCS
   vector/align16/add.cl
   vector/align16/cpu_inplace_mul.cl
   vector/align16/cpu_mult.cl
   vector/align16/divide.cl
   vector/align16/inplace_add.cl
   vector/align16/inplace_divide.cl
   vector/align16/inplace_mult.cl
   vector/align16/inplace_sub.cl
   vector/align16/mult.cl
   vector/align16/sub.cl
   vector/align1/add.cl
   vector/align1/clear.cl
   vector/align1/cpu_inplace_mul_add.cl
   vector/align1/cpu_inplace_mult.cl
   vector/align1/cpu_mul_add.cl
   vector/align1/cpu_mult.cl
   vector/align1/diag_precond.cl
   vector/align1/divide.cl
   vector/align1/index_norm_inf.cl
   vector/align1/inner_prod.cl
   vector/align1/inplace_add.cl
   vector/align1/inplace_div_add.cl
   vector/align1/inplace_divide.cl
   vector/align1/inplace_div_sub.cl
   vector/align1/inplace_mul_add.cl
   vector/align1/inplace_mul_sub.cl
   vector/align1/inplace_mult.cl
   vector/align1/inplace_sub.cl
   vector/align1/mul_add.cl
   vector/align1/mul_sub.cl
   vector/align1/mult.cl
   vector/align1/norm_1.cl
   vector/align1/norm_2.cl
   vector/align1/norm_inf.cl
   vector/align1/plane_rotation.cl
   vector/align1/sqrt_sum.cl
   vector/align1/sub.cl
   vector/align1/sum.cl
   vector/align1/swap.cl
   vector/align1/vmax.cl
   vector/align4/cpu_inplace_mul_add.cl
   vector/align4/cpu_mul_add.cl
   vector/align4/inplace_div_add.cl
   vector/align4/inplace_div_sub.cl
   vector/align4/inplace_mul_add.cl
   vector/align4/inplace_mul_sub.cl
   vector/align4/mul_add.cl)

set(FFT_SRCS
   fft/align1/bluestein_post.cl
   fft/align1/bluestein_pre.cl
   fft/align1/complex_to_real.cl
   fft/align1/fft_div_vec_scalar.cl
   fft/align1/fft_mult_vec.cl
   fft/align1/real_to_complex.cl
   fft/align1/reverse_inplace.cl
   fft/align1/transpose.cl
   fft/align1/transpose_inplace.cl
   fft/align1/vandermonde_prod.cl
   fft/align1/zero2.cl
   )

set(SPAI_SRCS
   spai/align1/assemble_blocks.cl
   spai/align1/block_bv_assembly.cl
   spai/align1/block_least_squares.cl
   spai/align1/block_q_mult.cl
   spai/align1/block_qr.cl
   spai/align1/block_qr_assembly.cl
   spai/align1/block_qr_assembly_1.cl
   spai/align1/block_r_assembly.cl
   )

set(CL_SRCS)
foreach(f IN LISTS COMPRESSED_MATRIX_SRCS COORDINATE_MATRIX_SRCS
      MATRIX_COL_SRCS MATRIX_ROW_SRCS SCALAR_SRCS VECTOR_SRCS FFT_SRCS SPAI_SRCS)
   get_filename_component(d "${CMAKE_CURRENT_BINARY_DIR}/${f}" PATH)
   file(MAKE_DIRECTORY "${d}")
   configure_file(${f} "${CMAKE_CURRENT_BINARY_DIR}/${f}" COPYONLY)
   list(APPEND CL_SRCS "${CMAKE_CURRENT_BINARY_DIR}/${f}")
endforeach()
list(APPEND CL_SRCS ${MATRIX_PROD_SRCS} ${MATRIX_SOLVE_SRCS})

add_executable(converter converter.cpp)
target_link_libraries(converter ${Boost_LIBRARIES})

set(KERNEL_HDRS)
set(KERNEL_SRCS)
foreach(d
      compressed_matrix
      coordinate_matrix
      matrix_col
      matrix_prod_col_col_col
      matrix_prod_col_col_row
      matrix_prod_col_row_col
      matrix_prod_col_row_row
      matrix_prod_row_col_col
      matrix_prod_row_col_row
      matrix_prod_row_row_col
      matrix_prod_row_row_row
      matrix_row
      matrix_solve_col_col
      matrix_solve_col_row
      matrix_solve_row_col
      matrix_solve_row_row
      scalar
      vector
      fft
      spai
      )
   set(f "${PROJECT_SOURCE_DIR}/viennacl/linalg/kernels/${d}")
   list(APPEND KERNEL_HDRS "${f}_kernels.h")
   list(APPEND KERNEL_SRCS "${f}_source.h")
endforeach()

file(MAKE_DIRECTORY "${PROJECT_SOURCE_DIR}/viennacl/linalg/kernels")

add_custom_command(OUTPUT ${KERNEL_HDRS} ${KERNEL_SRCS}
   COMMAND converter
   DEPENDS ${CL_SRCS}
   WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
   COMMENT "Generating kernel headers and sources"
   VERBATIM)

add_custom_target(kernels ALL
   DEPENDS ${KERNEL_HDRS} ${KERNEL_SRCS})

=== doc/CMakeLists.txt ===
if(BUILD_DOXYGEN_DOCS)
   configure_file(Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
   add_custom_command(OUTPUT
      ${CMAKE_CURRENT_BINARY_DIR}/doxygen/html/index.html
      COMMAND ${DOXYGEN_EXECUTABLE}
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      VERBATIM)
   # Runs only once
   add_custom_target(apidoc-all ALL
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/doxygen/html/index.html)
   # For manual updates
   add_custom_target(apidoc
      COMMAND ${DOXYGEN_EXECUTABLE}
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      VERBATIM)
endif()

if(BUILD_MANUAL)
   set(MANUAL_SRCS
      manual/algorithms.tex
      manual/benchmarks.tex
      manual/changelogs.tex
      manual/contributors.tex
      manual/cover.tex
      manual/custom-contexts.tex
      manual/custom-kernels.tex
      manual/design.tex
      manual/figures/logo_px200.eps
      manual/figures/matvec2.eps
      manual/figures/note.eps
      manual/figures/solver.eps
      manual/figures/tip.eps
      manual/figures/TU_Signet_CMYK.eps
      manual/IEEEtran_v1.13.bst
      manual/installation.tex
      manual/introduction.tex
      manual/keywords.tex
      manual/license.tex
      manual/multi-device.tex
      manual/operations.tex
      manual/other-libs.tex
      manual/setup.tex
      manual/tuning.tex
      manual/types.tex
      manual/versioning.tex
      manual/viennacl.bib
      manual/viennacl.tex)

   set(MANUAL_OBJS
      "${CMAKE_CURRENT_BINARY_DIR}/viennacl.pdf"
      "${CMAKE_CURRENT_BINARY_DIR}/manual/viennacl.bbl"
      "${CMAKE_CURRENT_BINARY_DIR}/manual/viennacl.blg"
      "${CMAKE_CURRENT_BINARY_DIR}/manual/viennacl.dvi"
      "${CMAKE_CURRENT_BINARY_DIR}/manual/viennacl.idx"
      "${CMAKE_CURRENT_BINARY_DIR}/manual/viennacl.log"
      "${CMAKE_CURRENT_BINARY_DIR}/manual/viennacl.out"
      "${CMAKE_CURRENT_BINARY_DIR}/manual/viennacl.ps"
      "${CMAKE_CURRENT_BINARY_DIR}/manual/viennacl.toc")
   foreach(f IN LISTS MANUAL_SRCS)
      configure_file(${f} ${CMAKE_CURRENT_BINARY_DIR}/${f} COPYONLY)
      if(f MATCHES "(.*)\\.tex$")
         list(APPEND MANUAL_OBJS
            "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_MATCH_1}.aux")
      endif()
   endforeach()

   add_custom_command(OUTPUT ${MANUAL_OBJS}
      COMMAND ${LATEX_COMPILER} viennacl.tex
      COMMAND ${LATEX_COMPILER} viennacl.tex
      COMMAND ${BIBTEX_COMPILER} viennacl
      COMMAND ${LATEX_COMPILER} viennacl.tex
      COMMAND ${BIBTEX_COMPILER} viennacl
      COMMAND ${LATEX_COMPILER} viennacl.tex
      COMMAND ${DVIPS_CONVERTER} -Ppdf -G0 -ta4 viennacl.dvi
      COMMAND ${PS2PDF_CONVERTER} -dPDFSETTINGS=/prepress
         -dCompatibilityLevel=1.3 -dMAxSubsetPct=100 -dSubsetFonts=true
         -dEmbedAllFonts=true -sPAPERSIZE=a4 -dAutoRotatePages=/None
         -dOptimize=true viennacl.ps ../viennacl.pdf
      DEPENDS ${MANUAL_SRCS}
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/manual
      COMMENT "Generating manual viennacl.pdf"
      VERBATIM)

   add_custom_target(manual ALL
      DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/viennacl.pdf")
endif()

=== examples/CMakeLists.txt ===
set(EXAMPLES_TESTDATA
   testdata/mat65k.mtx
   testdata/README
   testdata/result65025.txt
   testdata/rhs65025.txt)
foreach(f IN LISTS EXAMPLES_TESTDATA)
   configure_file(${f} "${CMAKE_CURRENT_BINARY_DIR}/${f}" COPYONLY)
endforeach()

add_subdirectory(tutorial)
add_subdirectory(benchmarks)
add_subdirectory(parameters)

=== tests/CMakeLists.txt ===
foreach(PROG blas3 fft iterators matrix matrix_range scalar sparse structured-matrices vector vector_range)
   add_executable(${PROG}-test src/${PROG}.cpp)
   target_link_libraries(${PROG}-test ${OPENCL_LIBRARIES})
   add_test(${PROG} ${PROG}-test)
endforeach(PROG)

include_directories(${PROJECT_SOURCE_DIR}/external)
add_executable(external_linkage 
                src/external_1.cpp
                src/external_2.cpp 
                ${PROJECT_SOURCE_DIR}/external/pugixml/src/pugixml.cpp)
target_link_libraries(external_linkage ${OPENCL_LIBRARIES})

=== examples/benchmarks/CMakeLists.txt ===
foreach(bench blas3 opencl vector)
   add_executable(${bench}bench ${bench}.cpp)
   target_link_libraries(${bench}bench ${OPENCL_LIBRARIES})
endforeach()

if(ENABLE_UBLAS)
   include_directories(${Boost_INCLUDE_DIRS})
   foreach(bench sparse solver)
      add_executable(${bench}bench ${bench}.cpp)
      target_link_libraries(${bench}bench ${OPENCL_LIBRARIES})
   endforeach()
endif()

=== examples/parameters/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/external)

foreach(par vector matrix sparse parameter_reader)
   set(n ${par}params)
   if(par STREQUAL parameter_reader)
      set(n ${par})
   endif()
   add_executable(${n} ${par}.cpp
      ${PROJECT_SOURCE_DIR}/external/pugixml/src/pugixml.cpp)
   target_link_libraries(${n} ${OPENCL_LIBRARIES})
endforeach()

if(ENABLE_VIENNAPROFILER)
   include_directories(${VIENNAPROFILER_INCLUDE_DIRS})
   foreach(par vector matrix sparse)
      add_executable(${par}params_vprof ${par}.cpp
         ${PROJECT_SOURCE_DIR}/external/pugixml/src/pugixml.cpp)
      target_link_libraries(${par}params_vprof
         ${OPENCL_LIBRARIES} ${VIENNAPROFILER_LIBRARIES})
   endforeach()

   set_target_properties(vectorparams_vprof matrixparams_vprof
      sparseparams_vprof
      PROPERTIES COMPILE_DEFINITIONS ENABLE_VIENNAPROFILER)
endif()

=== examples/tutorial/CMakeLists.txt ===
foreach(tut bandwidth-reduction blas1 custom-kernels custom-context fft viennacl-info)
   add_executable(${tut} ${tut}.cpp)
   target_link_libraries(${tut} ${OPENCL_LIBRARIES})
endforeach()

if(ENABLE_UBLAS)
   include_directories(${Boost_INCLUDE_DIRS})
   foreach(tut amg blas2 blas3 iterative iterative-ublas matrix-range qr spai structured-matrices vector-range)
      add_executable(${tut} ${tut}.cpp)
      target_link_libraries(${tut} ${OPENCL_LIBRARIES})
   endforeach()
endif()

if(ENABLE_EIGEN)
   include_directories(${EIGEN_INCLUDE_DIR})
   add_executable(iterative-eigen iterative-eigen.cpp)
   add_executable(eigen-with-viennacl
      eigen-with-viennacl.cpp)
   target_link_libraries(eigen-with-viennacl ${OPENCL_LIBRARIES})
endif()

if(ENABLE_MTL4)
   foreach(tut iterative-mtl4 mtl4-with-viennacl)
      add_executable(${tut} ${tut}.cpp)
      target_link_libraries(${tut} ${OPENCL_LIBRARIES})
   endforeach()
endif()

=== debian/changelog ===
viennacl (1.2.0-1) unstable; urgency=low

  * Make debian/copyright lintian clean
  * Improve debian/gbp.conf
  * New upstream version 1.2.0
  * Reworked packaging for new build system
  * Removed obsolete patches
  * Added 0001-Define-OPENCL_INCLUDE_DIRS-in-cmake-FindOpenCL.cmake.patch
  * Updated debian/watch file for appended -src suffix
  * Bump required cmake version to 2.8
  * Added get-orig-source target to debian/rules
  * Added 0002-Double-precision-on-AMD-GPUs-in-version-1.2.0.patch
  * Added 0003-Fix-adding-a-new-compute-device.patch
  * Update Standards-Version to 3.9.3

 -- Michael Wild <themiwi@users.sourceforge.net>  Mon, 27 Feb 2012 10:00:46 +0100

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Michael Wild <themiwi@users.sourceforge.net>
 Build-Depends: debhelper (>= 7.0.50~), poppler-utils, asciidoc, lynx,
- cmake (>= 2.6), libboost-filesystem-dev, texlive-latex-extra,
+ cmake (>= 2.8), libboost-filesystem-dev, texlive-latex-extra,
  texlive-latex-recommended, texlive-fonts-recommended, texlive-pstricks,
  ghostscript, doxygen, opencl-headers, libopencl1
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 DM-Upload-Allowed: yes
 Homepage: http://viennacl.sourceforge.net
 Vcs-Git: git://git.debian.org/git/debian-science/packages/viennacl.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# This has to be exported to make some magic below work.
export DH_OPTIONS

DEBDIR := $(dir $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST)))
PKGDIR := $(dir $(abspath $(DEBDIR)))
BUILDDIR := obj-$(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

%:
	dh $@

override_dh_auto_configure:
	rm -rf CL
	dh_auto_configure

override_dh_auto_test: $(BUILDDIR)/test_compute_capability
	if $(BUILDDIR)/test_compute_capability; then                          \
	  dh_auto_test;                                                       \
	else                                                                  \
	  echo '== SKIPPING TESTS BECAUSE NO OPENCL CAPABILITY FOUND ==' >&2; \
	fi

override_dh_auto_install:
	pdftotext -f 54 -l 58 -nopgbrk -r 150                                 \
	  -x 130 -y 160 -W 980 -H 1440 -enc ASCII7                            \
	  $(BUILDDIR)/doc/viennacl.pdf - |                                    \
	  sed -e 's/^Change Logs/= &\n/'                                      \
	      -e '/^Version [0-9]\.[0-9]\.x/d'                                \
	      -e 's/^Version [0-9]\./== &/'                                   \
	      -e '/^\* / i \ ' |                                              \
	  asciidoc -f /etc/asciidoc/text.conf - |                             \
	  lynx -dump --stdin > $(BUILDDIR)/changelog
	for t in dev doc; do                                                  \
	  sed 's|@BUILDDIR@|$(BUILDDIR)|g' debian/libviennacl-$$t.docs.in >   \
	  debian/libviennacl-$$t.docs;                                        \
	done
	dh_auto_install

$(BUILDDIR)/test_compute_capability: debian/test_compute_capability.c
	gcc -o $@ `dpkg-buildflags --get CFLAGS`                              \
	  `dpkg-buildflags --get LDFLAGS` -I/usr/include/nvidia-current $^    \
	  -lOpenCL

get-orig-source:
	TMPDIR=`mktemp -d`;                                                   \
	echo TMPDIR = $$TMPDIR;                                               \
	cd $(PKGDIR);                                                         \
	uscan --download-current-version --no-symlink --destdir $$TMPDIR;     \
	VERSION=`dpkg-parsechangelog |                                        \
	  awk '/^Version:/{print gensub(/-.*/, "", 1, $$2)}'`;                \
	cd $$TMPDIR;                                                          \
	mkdir viennacl-$$VERSION.orig;                                        \
	tar -xzf ViennaCL-$$VERSION-src.tar.gz --strip-components=1           \
	  --directory viennacl-$$VERSION.orig;                                \
	rm -rf viennacl-$$VERSION.orig/test/build;                            \
	find viennacl-$$VERSION.orig -type f -name \*~ -delete;               \
	tar -cf viennacl_$$VERSION.orig.tar viennacl-$$VERSION.orig;          \
	gzip -9 viennacl_$$VERSION.orig.tar;                                  \
	mv viennacl_$$VERSION.orig.tar.gz $(CURDIR);                          \
	cd $(CURDIR);                                                         \
	rm -rf $$TMPDIR
